Package org.opencv.xfeatures2d

## Class SIFT

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features2d.Feature2D
    - - org.opencv.xfeatures2d.SIFT

-     public class SIFT
      extends Feature2D

  Class for extracting keypoints and computing descriptors using the Scale Invariant Feature Transform (SIFT) algorithm by D. Lowe CITE: Lowe04 .

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `SIFT​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static SIFT` | `__fromPtr__​(long addr)` |
    `static SIFT` | `create()` | (measured in SIFT algorithm as the local contrast) number of octaves is computed automatically from the image resolution.
    `static SIFT` | `create​(int nfeatures)` |
    `static SIFT` | `create​(int nfeatures, int nOctaveLayers)` |
    `static SIFT` | `create​(int nfeatures, int nOctaveLayers, double contrastThreshold)` |
    `static SIFT` | `create​(int nfeatures, int nOctaveLayers, double contrastThreshold, double edgeThreshold)` |
    `static SIFT` | `create​(int nfeatures, int nOctaveLayers, double contrastThreshold, double edgeThreshold, double sigma)` |
    `protected void` | `finalize()` |

    - ### Methods inherited from class org.opencv.features2d.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, getDefaultName, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SIFT

          protected SIFT​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static SIFT __fromPtr__​(long addr)

    - #### create

          public static SIFT create​(int nfeatures,
                                    int nOctaveLayers,
                                    double contrastThreshold,
                                    double edgeThreshold,
                                    double sigma)

      Parameters:
        `nfeatures` - The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
        `nOctaveLayers` - The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution.
        `contrastThreshold` - The contrast threshold used to filter out weak features in semi-uniform (low-contrast) regions. The larger the threshold, the less features are produced by the detector.
        `edgeThreshold` - The threshold used to filter out edge-like features. Note that the its meaning is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained).
        `sigma` - The sigma of the Gaussian applied to the input image at the octave \#0. If your image is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### create

          public static SIFT create​(int nfeatures,
                                    int nOctaveLayers,
                                    double contrastThreshold,
                                    double edgeThreshold)

      Parameters:
        `nfeatures` - The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
        `nOctaveLayers` - The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution.
        `contrastThreshold` - The contrast threshold used to filter out weak features in semi-uniform (low-contrast) regions. The larger the threshold, the less features are produced by the detector.
        `edgeThreshold` - The threshold used to filter out edge-like features. Note that the its meaning is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained). is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### create

          public static SIFT create​(int nfeatures,
                                    int nOctaveLayers,
                                    double contrastThreshold)

      Parameters:
        `nfeatures` - The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
        `nOctaveLayers` - The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution.
        `contrastThreshold` - The contrast threshold used to filter out weak features in semi-uniform (low-contrast) regions. The larger the threshold, the less features are produced by the detector. is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained). is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### create

          public static SIFT create​(int nfeatures,
                                    int nOctaveLayers)

      Parameters:
        `nfeatures` - The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
        `nOctaveLayers` - The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution. (low-contrast) regions. The larger the threshold, the less features are produced by the detector. is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained). is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### create

          public static SIFT create​(int nfeatures)

      Parameters:
        `nfeatures` - The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast) number of octaves is computed automatically from the image resolution. (low-contrast) regions. The larger the threshold, the less features are produced by the detector. is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained). is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### create

          public static SIFT create()

      (measured in SIFT algorithm as the local contrast) number of octaves is computed automatically from the image resolution. (low-contrast) regions. The larger the threshold, the less features are produced by the detector. is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained). is captured with a weak camera with soft lenses, you might want to reduce the number.
      Returns:
        automatically generated

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `java.lang.Throwable`